/*
   Decoder Module include file
   (c) 2000 Jay
*/
#ifndef __dm_tilemod_h
#define __dm_tilemod_h

#define NULL 0

/* export structure */
typedef struct
{
   void (*entry)();

   int (*tile_pack)(unsigned char *dest,const unsigned char *src,int width,int height);
   int (*tile_unpack)(unsigned char *dest,const unsigned char *src,int width,int height);

   int (*update)(unsigned char *screen,void *data,long offset,int width,int height,int col,int row);
   int (*save)(unsigned char *data,int x,int y,int width,int height);

   int minwidth;
   int minheight;
   int maxwidth;
   int maxheight;
   int bpp;

   int maxpal;
   const char *modestr;
   const char **help;

   unsigned char key[4];
   void (*KeyHandler[4])();
} EXPORTSTRUC;

/* import struct */
typedef struct
{
   unsigned char *scratch;
   const char **SystemHelp;

   void * (*AllocateBuffer)(const char *name,unsigned long size);

   void * (*AllocMemory)(unsigned size);
   void * (*ReAllocMemory)(void *ptr,unsigned size);
   void   (*FreeMemory)(void *ptr);

   void * (*MemoryCopy)(void *dest,const void *src,unsigned int len);
   void * (*MemoryFill)(void *src,int c,unsigned int len);

   char * (*StringCopy)(char *dest,const char *src);
   int    (*StringCompare)(const char *a,const char *b);

   int    (*sprintf)(char *buf,const char *format,...);

   void (*WriteString)(const char *text,int x,int y);
   void (*WriteStringF)(const char *format,int x,int y,...);

   void (*Pixel)(int x,int y);
   void (*Line)(int x1,int y1,int x2,int y2);
   void (*Rect)(int x,int y,int width,int height);
   void (*FillRect)(int x,int y,int width,int height);
   void (*Blit)(void *data,int x,int y,int width,int height);

   void (*SetColor)(int R,int G,int B);
} IMPORTSTRUC;

#define scratch import.scratch
#define SystemHelp import.SystemHelp

#define AllocateBuffer import.AllocateBuffer

#define AllocMemory import.AllocMemory
#define ReAllocMemory import.ReAllocMemory
#define FreeMemory import.FreeMemory

#define MemoryCopy import.MemoryCopy
#define MemoryFill import.MemoryFill

#define StringCopy import.StringCopy
#define StringCompare import.StringCompare

#define sprintf import.sprintf

#define WriteString import.WriteString
#define WriteStringF import.WriteStringF

#define Pixel import.Pixel
#define Line import.Line
#define Rect import.Rect
#define FillRect import.FillRect
#define Blit import.Blit
#define SetColor import.SetColor

static const IMPORTSTRUC import = {0};
extern EXPORTSTRUC export;

#endif